<template>
    <div v-if="!isLoadedAll" class="films" ref="films">
        <div class="header-page">
            <div class="title">
<!--                Доступные фильмы-->
                <span :class="typePage==='films'?'active':''" @click="setType('films')">Фильмы</span>
                <span :class="typePage==='serials'?'active':''" @click="setType('serials')">Сериалы</span>
                <span :class="typePage==='Cartoon'?'active':''" @click="setType('Cartoon')">Мультфильмы</span>
            </div>
            <div class="options">
                <div class="btn" :class="{'active':notEndedFlag}" title="Отложенный просмотр" @click="notEndedFlag = !notEndedFlag">
                    <div class="ico-time"></div>
                </div>
                <div class="btn favorite" :class="{'active':favoriteFlag}" title="Избранные фильмы" @click="favoriteFlag = !favoriteFlag">
                    <i class="fas fa-star"></i>
                </div>

                <div class="sort">
                    Сортировать по:
                    <div class="list">
                        <router-link :to="{name: 'FilmsIndex'}">умолчанию</router-link>
                        <router-link :to="{name: 'FilmsIndex', query: {sort:'name'}}">имени</router-link>
                        <router-link :to="{name: 'FilmsIndex', query: {sort:'year'}}">году</router-link>
                        <router-link :to="{name: 'FilmsIndex', query: {sort:'genres'}}">жанру</router-link>
                    </div>
                    <div class="sort-type">
                        <span class="type-sort" :class="sortIndex === '+' ? 'active':''" @click="sortIndex = '+' "> <fa icon="sort-amount-up"  /> </span>
                        <span class="type-sort" :class="sortIndex === '-' ? 'active':''" @click="sortIndex = '-' "> <fa icon="sort-amount-down" /> </span>
                    </div>
                </div>
                <select-part :list="FilmsGenres" :choosen="chooseGenre.title" :routeType="'FilmsList'" @choose="onChoose" ></select-part>
                <div class="filter-ico" :class="filter ? 'active':''" @click="filter = !filter" ></div>
                <div class="clear" @click="clearFilter" title="Очистить фильтр">x</div>
            </div>
            <div class="filter" v-if="filter">
                <input type="text" class="search-film" placeholder="Название" v-model="search"/>
                <input type="text" class="search-film" placeholder="Актер" v-model="filterActor"/>
                <input type="text" class="search-film" placeholder="Режисер" v-model="filterDirector"/>
                <input type="text" class="search-film" placeholder="Год" v-model="filterYear"/>
            </div>
        </div>
        <div class="body-page">

            <div v-if="isLoaded" class="loading-container" style="height: 70vh"><div class="loading-box"></div></div>
            <div v-else>
                <list-films :films="paginatedData"></list-films>
                <div class="loading-progress" v-if="!isAllFilmsLoad">
                    <div class="loading-box"></div>
                </div>
                <div class="pagination" v-if="pageCount > 1 && isAllFilmsLoad">
                    <div class="pagination-btn"><div class="prev-page btn btn-default" @click="prevPage" v-if="paginationPage>0">Предыдущие</div></div>
                    <div class="pagination-list">
                        <ul class="list-page">
                            <li v-for="page in pages" class="item-page">
                                <div class="btn" @click="returnPage(page)" :class="{'active' : (page === paginationPage+1)}">{{page}}</div>
                            </li>
                        </ul>
                    </div>
                    <div class="pagination-btn"><div class="next-page btn btn-default" @click="nextPage" v-if="paginationPage<=pageCount-2" >Следующие</div></div>
                </div>
            </div>

        </div>
    </div>
    <div v-else class="loading-container"><div class="loading-box"></div></div>
</template>

<script>
    import ListFilms from "@/components/films/ListFilms";
    import selectPart from "@/components/select";
    import {store} from "../../main";

    export default {
        name: "index",
        components: {ListFilms,selectPart},
        data() {
            return {
                search: '',
                typePage: 'films',
                filterYear: '',
                filterActor: '',
                filterDirector: '',
                pageNumber: 0,
                size: 20,
                maxPage: 1,
                paginationPage: 0,
                chooseGenre: {id: "All", title: "Все"},
                sortIndex: '+',
                filter: false,
                notEndedFlag: false,
                favoriteFlag: false
            };
        },
        computed: {
            isLoadedAll() {
                return this.$store.getters.isLoading('filmPage') ? this.$store.getters.isLoading('filmPage') : false;
            },
            isAllFilmsLoad() {
                return this.$store.state.loadAllFilmsFlag;
            },
            sFilterYear() {
                this.filterYear = this.$route.query.year ? this.$route.query.year : '';
                return this.$route.query.year ? this.$route.query.year : null;
            },
            sFilterActor() {
                this.filterActor = this.$route.query.actor ? this.$route.query.actor : '';
                return this.$route.query.actor ? this.$route.query.actor : null;
            },
            sFilterDirector() {
                this.filterActor = this.$route.query.director ? this.$route.query.director : '';
                return this.$route.query.director ? this.$route.query.director : null;
            },
            films() {
                let allFilms = this.$store.getters.getFilms;

                let sortFilms = [];
                if (!this.$route.query.sort ) {
                    sortFilms = this.$store.state.films_ids.map(id => this.$store.getters.getFilm(id));
                }
                else if (this.$route.query.sort === 'name' && this.sortIndex === '-') {
                    sortFilms = allFilms.sort((a,b) => (a.name < b.name) ? 1 : ((b.name < a.name) ? -1 : 0));
                }
                else if (this.$route.query.sort === 'name' && this.sortIndex === '+') {
                    sortFilms = allFilms.sort((a,b) => (a.name > b.name) ? 1 : ((b.name > a.name) ? -1 : 0));
                }
                else if (this.$route.query.sort === 'year' && this.sortIndex === '-') {
                    sortFilms = allFilms.sort((a,b) => (+a.year < +b.year) ? 1 : ((+b.year < +a.year) ? -1 : 0));
                }
                else if (this.$route.query.sort === 'year' && this.sortIndex === '+') {
                    sortFilms = allFilms.sort((a,b) => (+a.year > +b.year) ? 1 : ((+b.year > +a.year) ? -1 : 0));
                }
                else if (this.$route.query.sort === 'genres' && this.sortIndex === '-') {
                    sortFilms = allFilms.sort((a,b) => (a.genres < b.genres) ? 1 : ((b.genres < a.genres) ? -1 : 0));
                }
                else if (this.$route.query.sort === 'genres' && this.sortIndex === '+') {
                    sortFilms = allFilms.sort((a,b) => (a.genres > b.genres) ? 1 : ((b.genres > a.genres) ? -1 : 0));
                }

                let yearFilms = sortFilms;
                if (this.filterYear) {
                    yearFilms = sortFilms.filter((film) => {
                        return film.year.toLowerCase().match( this.filterYear.toLowerCase() )
                    });
                }

                let actorFilms = yearFilms;
                if (this.filterActor) {
                    actorFilms = yearFilms.filter((film) => {
                        return film.actors.toLowerCase().match( this.filterActor.toLowerCase() )
                    });
                }

                let directorFilms = actorFilms;
                if (this.filterDirector) {
                    return actorFilms.filter((film) => {
                        return film.director.toLowerCase().match( this.filterDirector.toLowerCase() )
                    });
                }

                return directorFilms;
            },
            gFilm: function() {
                if (this.chooseGenre.title === 'Избранные') {
                    return this.films.filter(film => film.favorite === 1);
                }
                else if (this.chooseGenre.id === 'top') {
                    return this.$store.getters.getFilmsTop;
                }
                else if (this.chooseGenre.id === 'topMonth') {
                    return this.$store.getters.getFilmsTopMonth;
                }
                else if (this.chooseGenre.id === 'topToday') {
                    return this.$store.getters.getFilmsTopToday;
                }
                else {
                    return this.films.filter((film) => {
                        return film.genres.match( this.chooseGenre.title )
                    });
                }
            },
            genres: function () {
                let films = this.gFilm;
                let allFilms = this.gFilm;

                if (this.typePage === 'Cartoon') {
                    allFilms = films.filter((film) => {
                        return film.genres.match( 'Мультфильмы' )
                    });
                } else if (this.typePage === 'serials') {
                    allFilms = films.filter(film => film.series.length > 0);
                } else {
                    allFilms = films;
                }

                if (this.notEndedFlag) {
                    allFilms = allFilms.filter(film => film.not_ended === 1);
                }
                if (this.favoriteFlag) {
                    allFilms = allFilms.filter(film => film.favorite === 1);
                }

                return allFilms;
            },
            filteredFilms() {
                this.paginationPage = 0;
                return this.genres.filter((film) => {
                    return film ? film.name.toLowerCase().match(this.search.toLowerCase()) : {}
                });
            },
            paginatedData() {
                const start = this.paginationPage * this.size,
                    end = this.isAllFilmsLoad ? start + this.size : 200;

                return this.filteredFilms.slice(start, end);
            },
            pageCount(){
                let l = this.filteredFilms.length,
                    s = this.size;
                return Math.ceil(l/s);
            },
            rangeStart: function () {
                var start = this.paginationPage - 2;
                if (start < 0) {
                    return 0;
                } else {
                    return start;
                }
            },
            rangeEnd: function () {
                var end = this.paginationPage + 2;
                return (end < this.pageCount-1) ? end : this.pageCount-1;
            },
            pages: function () {
                var pageList = [];
                for (var i = this.rangeStart; i<= this.rangeEnd; i++) {
                    pageList.push(i+1);
                }
                return pageList;
            },

            FilmsGenres () {
                return this.$store.getters.getFilmGenres
            },
            isLoaded() {
                return this.$store.getters.isLoading('films') ? this.$store.getters.isLoading('films') : false;
            },
        },
        methods: {
            onChoose (data) {
                this.paginationPage = 0;
                this.chooseGenre = data;
                this.$refs.films.scrollTop = 0;
            },

            setType(data) {
                this.typePage = data;
                this.clearFilter();
            },
            clearFilter() {
                this.onChoose( {id: "All", title: "Все"} );
                this.filterYear = '';
                this.filterActor = '';
                this.filterDirector = '';
                this.search = '';
                this.notEndedFlag = false;
                this.favoriteFlag = false;
            },

            nextPage: function () {
                this.paginationPage++;
                this.$refs.films.scrollTop = 0;
            },
            prevPage: function () {
                this.paginationPage--;
                this.$refs.films.scrollTop = 0;
            },
            returnPage: function (num) {
                this.paginationPage = num-1;
                this.$refs.films.scrollTop = 0;
            },
        },
        beforeMount() {
            console.log('this.filterYear',this.filterYear);

            this.filterYear = this.$route.query.year ? this.$route.query.year : '';
            this.filterActor = this.$route.query.actor ? this.$route.query.actor : '';
            this.filterDirector = this.$route.query.director ? this.$route.query.director : '';

            console.log('this.filterYear',this.filterActor);

            !this.$store.state.filmsGenres_ids.length > 0 ? this.$store.dispatch('loadFilmsGenres') : true;
            // !this.$store.state.loadAllMovies ? this.$store.dispatch('loadFilms') : true;

            this.chooseGenre = this.$route.params.genreFilter ?  this.$route.params.genreFilter : {id: "All", title: "Все"};
        },
        mounted() {
            this.$store.state.top_films_ids_all.length <= 0 ? this.$store.dispatch('loadFilmPage') : true;
        },
    }
</script>

<style scoped lang="scss">

    .loading-progress {
        height: 100px;
        position: relative;
    }

    .title {
        width: 100%;
        margin-bottom: 10px;
        font-size: 24px !important;

        span {
            padding: 5px 10px;
            border-radius: 5px;
            cursor: pointer;

            &.active {
                background: #0b4882;
            }
        }
    }

    .options {
        display: flex;
        align-items: center;
        margin-left: auto;
        width: 100%;

        .btn {
            margin-right: 10px;
            padding: 8px 12px !important;
            border: 1px solid #fff;
            font-size: 21px;

            &.favorite {
                margin-right: auto;
            }

            .ico-time {
                background: url(/images/time.svg) no-repeat center;
                background-size: contain;
                min-width: 25px;
                max-width: 25px;
                height: 25px
            }

            &.active {
                background: #0b4882;
                color: #fff;

                .ico-time {
                    background: url(/images/time.svg) no-repeat center;
                    background-size: contain;
                }
            }
        }
    }
    .light .options {
        .btn {
            .ico-time {
                background: url(/images/time-b.svg) no-repeat center;
                background-size: contain;
            }

            &.active {

                .ico-time {
                    background: url(/images/time.svg) no-repeat center;
                    background-size: contain;
                }
            }
        }
    }
    .search-film {
        width: 200px;
        border: 0;
        line-height: 40px;
        padding: 0 15px;
        background: #ffffff;
        height: 40px;
        border-radius: 5px;
        font-size: 15px;
    }
    .pagination {
        display: flex;
        align-items: center;
        justify-content: space-between;
        margin-top: 20px;
    }
    .pagination .pagination-btn {
        width: 180px;
    }
    .pagination .pagination-btn > div {
        padding: 10px 20px;
        border: 1px solid #f1f1f1;
        cursor: pointer;
    }
    .pagination .pagination-btn:last-child  {
        text-align: right;
    }
    .list-page {
        display: flex;
        align-items: center;
    }
    .list-page > li .btn {
        padding: 5px 15px !important;
        border: 1px solid #f1f1f1;
        cursor: pointer;
        margin: 0 5px;
    }
    .list-page > li .btn.active {
        opacity: .5;
    }

    .sort {
        position: relative;
        display: flex;
        align-items: center;
        color: rgba(255, 255, 255, 1);
        font-family: NS-B, serif;

        .list {
            display: flex;
            align-items: center;
            margin-left: 5px;

            a {
                font-family: NS-R, serif;
                padding: 0 3px;
                color: #478dcd;
                opacity: 0.5;

                &.router-link-exact-active {
                    opacity: 1;
                }
            }
        }

        .sort-type {
            display: flex;
            align-items: center;
            margin-left: 5px;

            .type-sort {
                padding: 0 5px;
                cursor: pointer;
                opacity: 0.5;

                &.active {
                    opacity: 1;
                }
            }
        }
    }

    .filter-ico {
        background: url(/images/filter.svg) no-repeat center;
        background-size: 60%;
        border: 1px solid rgba(255, 255, 255, 0.5);
        width: 40px;
        height: 40px;
        border-radius: 3px;
        cursor: pointer;
        margin-left: 10px;

        &.active {
            background-color: #0a4882;
            border-color: #0a4882;
        }
    }
    .clear {
        background-color: #d02e2e;
        border: 1px solid #d02e2e;
        width: 40px;
        height: 40px;
        border-radius: 3px;
        cursor: pointer;
        margin-left: 10px;
        display: flex;
        /* align-items: center; */
        justify-content: center;
        font-size: 26px;
        text-transform: unset;
        line-height: 34px;
        font-family: sans-serif;
        order: 3;
    }
    .filter {
        display: flex;
        align-items: center;
        min-width: calc(100% + 10px);
        max-width: calc(100% + 10px);
        margin: 10px -5px 0;

        input {
            flex: 1 1;
            margin: 0 5px;
        }
    }
    .header-page {
        flex-wrap: wrap;
        height: initial;
        min-height: 50px;
    }


    .light {
        .title {
            span {
                &.active {
                    color: #fff;
                    background: #478dcd;
                }
            }
        }
        .sort[data-v-2d861108] {
            color: #478dcd;
        }
        .filter-ico {
            background-color: #478dcd;
            border: 1px solid rgb(71, 141, 205);

            &.active {
                background-color: #0a4882;
                border-color: #0a4882;
            }
        }
    }

    @media (max-width: 1150px) {
        .options {
            margin-left: auto;
        }
    }
    @media (max-width: 1000px) {
        .pagination .pagination-btn {
            width: 0;
        }
        .pagination .pagination-btn .btn {
            display: none;
        }
    }
    @media (max-width: 930px) {
        .sort {
            font-size: 14px;
            flex-wrap: wrap;
            margin-left: 10px;

            .list {
                margin-left:0;
            }
        }
        .filter-ico {
            margin-left: 0;
        }
        .filter {
            flex-wrap: wrap;

            > input {
                min-width: calc(50% - 10px);
                max-width: calc(50% - 10px);
                flex: 0 0;
                margin-bottom: 10px;
            }
        }
    }
    @media (max-width: 767px) {
        .sort {
            font-size: 14px;
        }
        .filter-ico {
            margin-left: 0;
        }
        .options {
            flex-wrap: wrap;
            width: 100%;

            .btn {
                margin-bottom: 10px;
                height: 39px;
            }

            .select-part {
                min-width: calc(100% - 120px);
                max-width: calc(100% - 120px);
                order: 0;
                margin-left: 0;
                margin-bottom: 10px;
                margin-right: 0;
            }
            .sort {
                order: 2;
            }
            .filter-ico {
                order: 3;
                margin-left: auto;
            }
        }
    }
    @media (max-width: 470px) {
        .content-part .header-page .title {
            margin-bottom: 15px;
            font-size: 18px !important;
        }
        .sort {
            flex-wrap: wrap;
            width: calc(100% - 95px);
            margin-left: 0;

            .list {
                margin-left: 0;
            }
        }
    }
</style>
